//*BHEADER* :ts=8  -*- C++ -*-
/*****************************************************************************
 *
 *   |_|_|_  |_|_    |_    |_|_|_  |_		     C O M M U N I C A T I O N
 * |_        |_  |_  |_  |_        |_		               N E T W O R K S
 * |_        |_  |_  |_  |_        |_		                     C L A S S
 *   |_|_|_  |_    |_|_    |_|_|_  |_|_|_|_	                 L I B R A R Y
 *
 * $Id: Array2.c,v 0.27 1995/01/20 15:14:47 cncl-adm Exp cncl-adm $
 *
 * Class: Array2 --- Base class for 2-dimensional arrays
 *
 *****************************************************************************
 * Copyright (C) 1992-1995   Communication Networks
 *                           Aachen University of Technology
 *                           D-52056 Aachen
 *                           Germany
 *                           Email: cncl-adm@dfv.rwth-aachen.de
 *****************************************************************************
 * This file is part of the CN class library. All files marked with
 * this header are free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.  This library is
 * distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.  You should have received a copy of the GNU
 * Library General Public License along with this library; if not, write
 * to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 **EHEADER********************************************************************/

#include "Array2.h"

#include <strstream.h>



/*
 * Index out of range error message
 */
void CNArray2::range_error(int index) const
{
    char buffer[64];
    ostrstream str(buffer, sizeof(buffer));
    
    str << index << ends;
    
    fatal(NIL, class_desc()->name(),
	  ": index (row) [", buffer, "] out of range");
}


void CNArray2::range_error(int r, int c) const
{
    char buffer[64];
    ostrstream str(buffer, sizeof(buffer));
    
    str << "[" << r << "][" << c << "]" << ends;
    
    fatal(NIL, class_desc()->name(), ": index ", buffer, " out of range");
}



/***** CNCL stuff for type information ***************************************/

// Describing object for class Array2
static CNClass Array2_desc("Array2", "$Revision: 0.27 $", NIL);

// "Type" for type checking functions
CNClassDesc CN_ARRAY2 = &Array2_desc;
