//*BHEADER* :ts=8  -*- C++ -*-
/*****************************************************************************
 *
 *   |_|_|_  |_|_    |_    |_|_|_  |_		     C O M M U N I C A T I O N
 * |_        |_  |_  |_  |_        |_		               N E T W O R K S
 * |_        |_  |_  |_  |_        |_		                     C L A S S
 *   |_|_|_  |_    |_|_    |_|_|_  |_|_|_|_	                 L I B R A R Y
 *
 * $Id: Tab.c,v 0.27 1995/01/20 15:13:51 cncl-adm Exp cncl-adm $
 *
 * CNClass: CNTab --- CNRandom numbers from table
 *
 *****************************************************************************
 * Copyright (C) 1992-1995   Communication Networks
 *                           Aachen University of Technology
 *                           D-52056 Aachen
 *                           Germany
 *                           Email: cncl-adm@dfv.rwth-aachen.de
 *****************************************************************************
 * This file is part of the CN class library. All files marked with
 * this header are free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.  This library is
 * distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
 * License for more details.  You should have received a copy of the GNU
 * Library General Public License along with this library; if not, write
 * to the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 **EHEADER********************************************************************/

#include "Tab.h"



double CNTab::operator()()
{
    long index = pGenerator->as_long();

    index %= len;
    return (adr[index]);
}



/***** Default I/O member function for CNCL classes **************************/

// CNNormal output
void CNTab::print(ostream &strm) const
{
    strm << "n=" << len << " val={";
    for(int i=0; i<len; i++)
    {
	strm << adr[i];
	if(i < len-1)
	    strm << ",";
    }
    strm << "}" << endl;
}

// Debug output
void CNTab::dump(ostream &strm) const
{
    strm << "CNTab { "
	 << "n=" << len << " val={";
    for(int i=0; i<len; i++)
    {
	cout << adr[i];
	if(i < len-1)
	    cout << ",";
    }
    strm << "} }" << endl;
}



/***** CNCL stuff for type information and exemplar objects ******************/

// Describing object for class CNTab
static CNClass CNTab_desc("CNTab", "$Revision: 0.27 $", CNTab::new_object);

// "Type" for type checking functions
CNClassDesc CN_TAB = &CNTab_desc;






